function loadDemo(nomf) {
	var fileref=document.createElement('script');
	fileref.setAttribute("type","text/javascript");
	fileref.async = true;
	fileref.setAttribute("src", "demos/"+nomf+".js");
	var js=document.getElementsByTagName("head")[0].appendChild(fileref);
    js.onload = function () {
		cons (nomf+" chargé.");
		loadModele (tDemo);
		cacheSplash();
	}	
}

function saveResume () {
	var t="";
	t+="Résumé du modèle\r\n";
	t+="----------------\r\n";
	t+="\r\n";
	t+="Environnement :\r\n";
	t+="-------------\r\n";
	t+= nbLig+" lignes / "+nbCol+" colonnes\r\n";
	if (borderless) {t+="Environnement sans bords\r\n"}
	if (nbMaxInd>0) {t+="Nombre maximal d'individus : "+nbMaxInd+"\r\n"}
	t+="\r\n";
	t+="Agents :\r\n";
	t+="------\r\n";
	for (let e of tEnt) {
		t+="Nom :"+e.nom+"\r\n";	
		if (e.dvie>0) {t+="Demi-vie :"+e.dvie+"\r\n";}
		if (e.mobile) {
			t+="Probabilité de déplacement : "+e.vitesse+"\r\n";
		} else {t+="Immobile\r\n"}
		if (e.modePla=="auto") {
			t+="Effectif initial : "+e.nbInd+"\r\n";
		}
		t+="\r\n";	
	}
	
	t+="\r\n";
	t+="Règles :\r\n";
	t+="------\r\n";
	for (let c of tCpt) {
		t+="Nom de la règle :"+c.nom+"\r\n";	
		
		if (c.type=="reaction") {
			t+="Type : réaction entre agents \r\n";
			t+="Probabilité : "+c.proba+"%\r\n";
			if (c.condEff) {
				t+="Conditionnée à l'effectif de ";
				if (c.condEffAg==0) {t+="(case vide)"} else {t+=entById(c.condEffAg*1).nom}
				t+=" qui doit être ";
				if ((c.condEffTyp)=="inf") {t+="inférieur à "}
				if ((c.condEffTyp)=="sup") {t+="inférieur à "}
				if ((c.condEffTyp)=="egal") {t+="égal à "}
				if ((c.condEffTyp)=="diff") {t+="inférieur à "}
				t+=c.condEffVal+"\r\n";
			}
			
			if (c.delai>0) {t+="Age minimal des réactifs : "+c.delai+"%\r\n";}
			if (c.susp) {t+="(suspendue)\r\n"}
			t+="Réactifs : ";
			for (let r of c.tReac) {
				if (r!="") {t+=entById(r*1).nom+", "}
			}
			t=t.slice(0, -2);
			t+="\r\n";
			t+="Produits : ";
			for (let r of c.tProd) {
				if (r!="") {t+=entById(r*1).nom+", "}
			}
			t=t.slice(0, -2);
			t+="\r\n";
		}
		if (c.type=="spont") {
			t+="Type : apparition spontanée d'agents \r\n";
			t+="Probabilité : "+c.probaSpont+"%\r\n";
			if (c.condEff) {
				t+="Conditionnée à l'effectif de ";
				if (c.condEffAg==0) {t+="(case vide)"} else {t+=entById(c.condEffAg*1).nom}
				t+=" qui doit être ";
				if ((c.condEffTyp)=="inf") {t+="inférieur à "}
				if ((c.condEffTyp)=="sup") {t+="inférieur à "}
				if ((c.condEffTyp)=="egal") {t+="égal à "}
				if ((c.condEffTyp)=="diff") {t+="inférieur à "}
				t+=c.condEffVal+"\r\n";
			}
			t+="Produits : ";
			for (let r of c.tProd) {
				if (r!="") {t+=entById(r*1).nom+", "}
			}
			t=t.slice(0, -2);
			t+="\r\n";
		}
		t+="\r\n";
	}
	
	saveToText ("resume.txt",t);
}

function saveJson() {
	showId ("divPatience");
	setTimeout (function() {saveJson2()},10);	
}

function saveJson2 () {
	doResetAnim();
	if ((tEnt.length==0)&&(tCpt.length==0)&&(tZon.length==0)) {
		return false;
	}
	
	var tAll=new Object ();
	tAll.typeMod="algo";
	tAll.version=version;
	tAll.modeExpert=modeExpert;
	tAll.tEnt=JSON.parse(JSON.stringify(tEnt));
	// on vide les individus 
	for (let e of tAll.tEnt) {
		e.tInd=[];
	}
	tAll.tCpt=JSON.parse(JSON.stringify(tCpt));
	tAll.nbCol=nbCol;
	tAll.nbLig=nbLig;
	tAll.borderless=borderless;
	tAll.nbMaxInd=nbMaxInd;
	tAll.chauffe=chauffe;
	tAll.duree=duree;
	
	tAll.tZon=tZon;
	tAll.opaZone=opaZone;
	
	if (tZon.length>0) {
		tAll.damierZ0=damierZ0;
	} else {
		tAll.damierZ0=[];
	}
	
	if (hasImageBG) {
		var canv=byId("canvTemp64BG");
		tAll.imageBG=canv.toDataURL();;
	} else {
		tAll.imageBG="";
	}
	var allJson=JSON.stringify(tAll); 
	
	hideId ("divPatience");

	swal({   
		title: "Nom du fichier (sans extension)",   
		text: "Saisir le nom du fichier qui contiendra le modèle",   
		input: "text",
		showCancelButton: true,   
		allowEscapeKey:true,
		animation: "slide-from-top",   
		inputPlaceholder: "monModele" })
		.then(function(result) {
			if (result.value) {
				var fileNameToSaveAs=result.value;
				if (fileNameToSaveAs===null) {return false;}
				saveToText (fileNameToSaveAs+".modele",allJson);	
			}
        });
}

function saveCSVGraph () {
	var txt="\ufeff";
	txt+="Tour;";
	for (var j=0;j<tEnt.length;j++) {
		va=tEnt[j];
		txt+=va.nom+";";
	}
	txt+="\r\n";
	
	var iDebut=iTemps-nbMaxPtsGraph;
	if (iDebut<0) {iDebut=0;}
	
	for (var i=iDebut;i<iTemps;i++) {
		var ligne="";
		ligne+=i+";";

		for (var j=0;j<tEnt.length;j++) {
			ligne+=v=tGraph[j][i]+";";
		}
		ligne+="\r\n";
		ligne=ligne.replace (/\./g,",");
		txt+=ligne;
	}
	
	swal({   
		title: "Nom du fichier (sans extension)",   
		text: "Saisir le nom du fichier qui contiendra les données du graphique",   
		input: "text",
		showCancelButton: true,   
		allowEscapeKey:true,
		animation: "slide-from-top",   
		inputValue: "monGraphique",
		inputPlaceholder: "monGraphique" })
		.then(function(result) {
			if (result.value) {
				var fileNameToSaveAs=result.value;
				if (fileNameToSaveAs===null) {return false;}
				saveToText (fileNameToSaveAs+".csv",txt);
			}
        });
}

function saveToText(fileNameToSaveAs,textToWrite)
{
	var blob = new Blob([textToWrite], {
		type: "text/plain;charset=utf-8"
	});
	saveAs(blob, fileNameToSaveAs);
}

function destroyClickedElement(event)
{
    document.body.removeChild(event.target);
}

function loadJson (textLoaded) {
	var tAll=JSON.parse(textLoaded);	
	loadModele (tAll);
}

function checkDefaultMissing () {
	// affecte une valeur par défaut quand undefined
	for (let e of tEnt) {
		e.modePla=e.modePla||"auto";
		if (e.modePla=="manu") {
			e.nbInd=-1;
			e.tPla=e.tPla||[];
		}
	}
}

function loadModele (tAll) {
	showId ("divPatience");
	setTimeout (function() {loadModele2(tAll)},10);
}

function loadModele2 (tAll) {
	let typeMod=tAll.typeMod||"";
	
	versionModeleCharge=tAll.version||"";

	
	if (typeMod!="") {
		if (typeMod!="algo") {
			if (typeMod=="ana") {
				// ce fichier doit s'ouvrir avec ana
				swal({
				  title: 'Modèle analytique',
				  text: "Ce modèle a été créé avec le module analytique. Voulez-vous basculer vers ce module ?",
				  type: 'warning',
				  showCancelButton: true,
				  confirmButtonColor: '#3085d6',
				  cancelButtonColor: '#d33',
				  confirmButtonText: 'Oui',
				  cancelButtonText: 'Non',
				  confirmButtonClass: 'btn btn-success',
				  cancelButtonClass: 'btn btn-danger',
				  buttonsStyling: true,
				  reverseButtons: false
				}).then((result) => {
				  if (result.value) {
					window.location.replace('../ana/index.htm');
					hideId ("divPatience");
					return false;
				  } else {
					hideId ("divPatience");
					return false;
				  }
				})
			}
			
			else {
				
				// mode inconnu
				swal({
				  type: 'error',
				  title: 'Erreur',
				  text: 'Ce fichier n\'a pas été prévu pour ce module d\'Edumodèle !'
				})
				hideId ("divPatience");
				return false;
			
			}
			return false;
		}
		
	}
	
	
	
	deleteBG();

	tEnt=tAll.tEnt;
	tCpt=tAll.tCpt;
	nbLig=tAll.nbLig;
	nbCol=tAll.nbCol;
	borderless=tAll.borderless||false;
	nbMaxInd=tAll.nbMaxInd||0;
	
	// zones
	if (typeof tAll.tZon=="undefined") {
		tZon=[];
	} else {
		tZon=tAll.tZon;
	}
	
	if (typeof tAll.modeExpert!="undefined") {
		ModeExpert=tAll.modeExpert;
	}
	
	initDamierZone();
	initDamier();
	if (tZon.length>0) {
		damierZ0=JSON.parse(JSON.stringify(tAll.damierZ0));
	} 
	
		// pour la rétrocompatibilité
	
	if (typeof tAll.opaZone=="undefined") {
		opaZone=50;
	} else {
		opaZone=tAll.opaZone;
	}
	
	if (typeof tAll.chauffe=="undefined") {
		chauffe=0;
	} else {
		chauffe=tAll.chauffe;
	}
	
	if (typeof tAll.duree=="undefined") {
		duree=0;
	} else {
		duree=tAll.duree;
	}
	
	

	if (typeof tAll.imageBG=="undefined") {hasImageBG=false;}
	else {
		if (tAll.imageBG=="") {
			hasImageBG=false;
		} else {
			hasImageBG=true;
			byId("imgPreviewBG").src = tAll.imageBG;
			byId("imgPreviewBG").onload = function () {
				hasImageBGChanged=true;
				imageBGSelected();
			}
		}
	}
	
	for (let e of tEnt) {
		delete e["tags"]; // tags a été supprimé
		if (typeof e.onGraph=="undefined") {e.onGraph=true;}
		if (typeof e.zoneDep=="undefined") {e.zoneDep=-1;}
		if (typeof e.zoneInit=="undefined") {e.zoneInit=-1;}
	}
	
	for (let c of tCpt) {
		c.susp=c.susp||false;
		if (typeof c.zone=="undefined") {c.zone=-1;}
		if (typeof c.zone2=="undefined") {c.zone2=-1;}
		if (c.type=="reaction") {
			c.ctr=c.ctr||false;
			for (let i=0;i<5;i++) {
				if (typeof c.tReac[i]=="undefined") {
					c.tReac[i]="";
				} else {
					c.tReac[i]=""+c.tReac[i];
				}
			}
			
			if (typeof c.tLink=="undefined") {c.tLink=[];}
			
			if (typeof c.condEff=="undefined") {c.condEff=false;}
						
			for (let i=0;i<5;i++) {
				if (typeof c.tLink[i]=="undefined") {
					c.tLink[i]=false;
				}
			}
			
			if (typeof c.tKeep=="undefined") {c.tKeep=[];}
			
			for (let i=0;i<5;i++) {
				if (typeof c.tKeep[i]=="undefined") {
					c.tKeep[i]=false;
				}
			}
			
		}
		for (let i=0;i<5;i++) {
			if (typeof c.tProd[i]=="undefined") {
				c.tProd[i]="";
			} else {
				c.tProd[i]=""+c.tProd[i];
			}
		}
	}
	
	checkDefaultMissing ();
	
	updateLigCol ();
	redimGrille();
		
	refreshListeEnt();
	updateTableauxReacProd();
	updateLegende();
	repeupleTout();
	
	refreshListeCpt();
	simplifieCpt();
	
	resizeCanvGraph();	
	
	byId("inputToursDeChauffe").value=chauffe;
	
	doResetAnim();	
	redim();
	
	montreExpert ();
	
	hideId ("divPatience");
	
	setTimeout(function() {
		redim();
		traceEntites();	
	},100);
	
	setTimeout(function() {
		redim();
		traceEntites();	
	},500); // parfois les images ne sont pas prêtes
}


function readSingleFile(evt) {
	if ((tEnt.length>0)||(tCpt.length>0)) {
		swal({
		  title: 'Le modèle actuel va être fermé',
		  text: "Charger un autre modèle va fermer celui-ci. Etes vous sûr de vouloir poursuivre ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			eraseAll ();
			readSingleFilePart2 (evt);
		  } else {
			return false;
		  }
		})
	} else {
		// modèle vide, on peut y aller direct
		eraseAll ();
		readSingleFilePart2(evt);
	}
}


	
function readSingleFilePart2(evt) {	
	//Retrieve the first (and only!) File from the FileList object
	var f = evt.target.files[0]; 
	
	if (f) {
	  var r = new FileReader();
	  r.onload = function(e) { 
		var contents = e.target.result;
		loadJson(contents);
	  }
	  r.readAsText(f);
	} else { 
	  	swal({
		  type: 'error',
		  title: 'Erreur',
		  text: 'Impossible de lire le fichier !'
		})
	}
	byId('fileinput').value = null;
 }
 