var selectedCpt=-1;
var tReacPos=[];
var tCpt=[];

function simplifieCpt () {
	// calcul de la balance
	for (var c of tCpt) {
		var nbProd=0;
		var bal=0;
		for (var r of c.tReac) {
			if ((r*1)>0) {bal--;}
		}
		for (var p of c.tProd) {
			if ((p*1)>0) {bal++;nbProd++;}
		}
		c.bal=bal;
		c.nbProd=nbProd;
	}
	
	// nombre de cases vides imposées dans les réactifs
	for (var c of tCpt) {
		var ncv=0;
		for (var r of c.tReac) {
			if (r=="0") {ncv++;}
		}
		c.ncv=ncv;
	}
}

function clicRetraitCpt() {
	if (selectedCpt<0) {return false}
	var cpt=tCpt[selectedCpt];
	swal({
		  title: 'Suppression',
		  text: "Etes vous sûr de vouloir supprimer la règle nommée "+cpt.nom+" ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			tCpt.splice(selectedCpt,1);
			refreshListeCpt();
		  } else {
			return false;
		  }
	})
}

function removeCptContenantEntId (id) {
	id+="";
	// on marque les cpt à supprimer
	for (let c of tCpt) {
		let r=c.tReac;
		let p=c.tProd;
		let ri=r.indexOf(id);
		let pi=p.indexOf(id);
		if ((ri>=0)||(pi>=0)) {
			c.nom="";
		}
		if (c.condEff) {
			if (c.condEffAg==id) { // si le cpt est conditionné à l'effectif de id
				c.nom=""; 
			}
		}
	}
	
	// on supprime ce qui a été marqué
	var ntCpt=tCpt.filter(r => r.nom!="");
	tCpt=JSON.parse(JSON.stringify(ntCpt));
	refreshListeCpt();
	simplifieCpt();
}


function suspendreCpt () {
	if (selectedCpt<0) {return false}
	tCpt[selectedCpt].susp=!tCpt[selectedCpt].susp;
	refreshListeNomCpt();
	selectCpt(selectedCpt);
}

function clickButEditComportement() {
	if (selectedCpt<0) {return false}
	
	affModale('divSaisieComportement');
	
	if (tZon.length==0) {
		hideId("divZoneCpt");
	} else {
		showId("divZoneCpt");
	}
	
	var cpt=tCpt[selectedCpt];
	changeTypeCpt(cpt.type);
	byId("inputNomComportement").value=cpt.nom;	
	byId("selectTypeCpt").value=cpt.type;
			
	updateTableauxReacProd();
	refreshListeZonesCpt();
	
	byId("checkReglEff").checked=cpt.condEff;
	if (cpt.condEff===true) {
		showId("divReglEff2");
		byId("inputEffReg").value=cpt.condEffVal;
		byId("selectInfSup").value=cpt.condEffTyp;
		byId("selectAgentEff").value=cpt.condEffAg;	
	} else {
		hideId("divReglEff2");	
	}	
	
	byId("selectTypeZoneCpt").value=cpt.zone;
	byId("selectTypeZoneCpt2").value=cpt.zone2;
		
	if (cpt.type=="spont") {
		byId("inputProbaSpont").value=cpt.probaSpont*1;
		byId("inputNombreProbaSpont").value=cpt.nbSpont*1;
		changeProbaSpont ();
		for (var n=1;n<6;n++) {
			var prod=cpt.tProd[n-1]||"";
			if (prod!="") {
				byId("selectProdS"+n).selectedIndex=getEntIndexById(prod*1)+1;
			}
		}
	} 

	// mise à jour réactifs et produits
	if (cpt.type=="reaction") {
		byId("checkCtr").checked=cpt.ctr;
		byId("inputAgeDelai").value=cpt.delai*1;
		byId("inputProbaReac").value=cpt.proba*1;
		for (var n=1;n<6;n++) {
			byId("checkLink"+n).checked=cpt.tLink[n-1];
			byId("checkKeep"+n).checked=cpt.tKeep[n-1];
			var reac=cpt.tReac[n-1]||"";
			if (reac!="") {
				byId("selectReac"+n).value=reac;
			} else {
				byId("selectReac"+n).value="-1";
			}
			var prod=cpt.tProd[n-1]||"";
			if (prod!="") {
				byId("selectProd"+n).selectedIndex=getEntIndexById(prod*1)+1;
			} else {
				byId("selectProd"+n).value="-1";	
			}
		}
	}
	
	byId("butSaisieComportement").innerHTML="Appliquer";
	byId("divTitreSaisieCpt").innerHTML="<b>Modifier une règle</b>";
	byId("butAnnulerComportement").innerHTML="Annuler la modification";
}

function changeTypeCpt (v) {
	for (var n=1;n<6;n++) {
		var sr=byId("selectReac"+n);
		var sp=byId("selectProd"+n);
		var sps=byId("selectProdS"+n);
		sr.selectedIndex=0;
		sp.selectedIndex=0;
		sps.selectedIndex=0;
		byId("checkKeep"+n).checked=false;
		byId("checkLink"+n).checked=false;
	}
		
	byId("checkCtr").checked=true;
	byId("inputProbaReac").value=25;
	byId("inputAgeDelai").value=0;
	
	byId("inputProbaSpont").value=50;
	changeProbaSpont ();
	
	if (v=="reaction") {
		showId("divRebornProduits");
		showId("tableReaction");
		hideId("tableSpont");
		showId ("divProbaReac");
		showId ("divAgeDelai");
		hideId ("divProbaSpont");
		showId ("selectReac2");
		showId ("selectReac3");
		showId ("selectReac4");
	} else if (v=="spont") {
		hideId("divRebornProduits");
		showId("tableSpont");
		hideId("tableReaction");
		hideId ("divProbaReac");
		hideId ("divAgeDelai");
		showId ("divProbaSpont");
	} 
	
}

function clicAjoutCpt () {
	byId("selectTypeCpt").value="reaction";
	
	if (tZon.length==0) {
		hideId("divZoneCpt");
	} else {
		showId("divZoneCpt");
	}
	
	changeTypeCpt("reaction");
	byId("inputNomComportement").value="";
	
	byId("checkReglEff").checked=false;
	hideId("divReglEff2");
	byId("selectAgentEff").selectedIndex=0;
	byId("selectInfSup").value="inf";
	byId("inputEffReg").value=10;
	
	byId("butSaisieComportement").innerHTML="Ajouter cette règle";
	byId("butAnnulerComportement").innerHTML="Annuler";
	byId("divTitreSaisieCpt").innerHTML="<b>Ajouter une nouvelle règle</b>";
	affModale('divSaisieComportement');
	refreshListeZonesCpt();
	updateTableauxReacProd();
}


function butOKsaisieComportement () {
	var nom=byId("inputNomComportement").value;
	var zone=byId("selectTypeZoneCpt").value*1;
	var zone2=byId("selectTypeZoneCpt2").value*1;
	var type=byId("selectTypeCpt").value;
	if (nom=="") {nom="Comportement n°"+(tCpt.length+1);}
	var cpt={};
	cpt.nom=nom;
	cpt.type=type;
	cpt.zone=zone;
	cpt.zone2=zone2;
	cpt.condEff=byId("checkReglEff").checked;
	if (cpt.condEff===true) {
		cpt.condEffVal=byId("inputEffReg").value*1;
		cpt.condEffTyp=byId("selectInfSup").value;
		cpt.condEffAg=byId("selectAgentEff").value*1;		
	}
	
	if (type=="reaction") {
		// ajout des réactifs et produits
		cpt.delai=byId("inputAgeDelai").value*1;
		cpt.ctr=byId("checkCtr").checked;
		var tProd=[];
		var tReac=[];
		var tLink=[];
		var tKeep=[];
		for (var n=1;n<6;n++) {
			var lk=byId("checkLink"+n).checked;
			var k=byId("checkKeep"+n).checked;
			var reac=byId("selectReac"+n).value;
			var prod=byId("selectProd"+n).value;
			if (reac!="-1") {tReac.push(reac)} else {tReac.push("")}
			if (prod!="-1") {tProd.push(prod)} else {tProd.push("")}
			tLink.push(lk);
			tKeep.push(k);
		}
		cpt.tProd=tProd;
		cpt.tReac=tReac;
		cpt.tLink=tLink;
		cpt.tKeep=tKeep;
		cpt.proba=byId("inputProbaReac").value*1;
		if (tReac.length==0) {
			swal({
			  type: 'error',
			  title: 'Erreur...',
			  text: "Aucun réactif n'a été saisi.",
			});
			return false;
		}
	};
	
	if (type=="spont") {
		// ajout des réactifs et produits
		cpt.probaSpont=byId("inputProbaSpont").value*1;
		cpt.nbSpont=byId("inputNombreProbaSpont").value*1;
		var tProd=[];
		var tReac=[];
		for (var n=1;n<6;n++) {
			var prod=byId("selectProdS"+n).value;
			if (prod!="-1") {tProd.push(prod)}
		}
		cpt.tProd=tProd;
		cpt.tReac=tReac;
	}
	
	cacheModale();	
	hideId("divSaisieComportement");
	
	// on regarde la première lettre A comme ajouter
	if (byId("butSaisieComportement").innerHTML[1]=="j") {
		cpt.susp=false;
		ajouteComportement(cpt);
	} else {
		cpt.susp=tCpt[selectedCpt].susp;
		modifieComportement(cpt);
	}
}

function modifieComportement (cpt) {
	tCpt[selectedCpt]=JSON.parse(JSON.stringify(cpt));
	refreshListeCpt();
	simplifieCpt();
}

function ajouteComportement(cpt) {
	tCpt.push(cpt);
	refreshListeCpt();
	simplifieCpt();
}

function effaceSelCpt () {
	for (let i=0;i<tCpt.length;i++) {
		let s=byId ("spanListeCpt"+i);
		s.style.backgroundColor="white";
		s.style.color="black";
	}
}

function selectCpt (i) {
	effaceSelCpt();
	selectedCpt=i;
	byId("spanSusp").innerHTML="Suspendre cette règle";
	
	if (i>=0) {
		if (tCpt[i].susp===true) {
			byId("spanSusp").innerHTML="Réactiver cette règle";
		}
		let s=byId ("spanListeCpt"+i);
		s.style.backgroundColor="#666";
		s.style.color="white";
	} 
}

function refreshListeNomCpt() {
	for (let i=0;i<tCpt.length;i++) {
		let spa=byId("spanListeCpt"+i);
		let susp="";
		if (tCpt[i].susp===true) {
			susp="<div style='display:inline-block;width:0.9em;height:0.9em;background-image: url(\"images/suspend.png\");background-size: contain;'></div>";
		} else {
			susp="";
		}
		spa.innerHTML=susp+tCpt[i].nom;
	}
}

function refreshListeCpt() {
	var d=byId("divListeRegles");
	t="";
	for (let i=0;i<tCpt.length;i++) {
		let c=tCpt[i];
		if (c.susp===true) {col="color:#AAA;"}
		t+="<div id=\"spanListeCpt"+i+"\" style=\"cursor:pointer;padding-left:0.2em;width:100%;\" ";
		t+="onclick=\"selectCpt("+i+")\" ";
		t+="ondblclick=\"clickButEditComportement()\" "
		t+=">";
		t+="</div>";
	}
	d.innerHTML=t;
	refreshListeNomCpt();
	simplifieCpt();
}

function checkEffCondCpt (cpt) {
	if (cpt.condEff===false) {return true;}
	let nInd;
	if (cpt.condEffAg>0) {nInd=entById(cpt.condEffAg).tInd.length;} else {nInd=nbCasesVides;}
	if ((cpt.condEffTyp)=="egal") {
		if (nInd!=cpt.condEffVal) {
			return false;
		}
	}
	if ((cpt.condEffTyp)=="diff") {
		if (nInd==cpt.condEffVal) {
			return false;
		}
	}
	if ((cpt.condEffTyp)=="sup") {
		if (nInd<=cpt.condEffVal) {
			return false;
		}
	}
	if ((cpt.condEffTyp)=="inf") {
		if (nInd>=cpt.condEffVal) {
			return false;
		}
	}		
	return true;
}

function checkReacPossible (cpt,x,y,id) {
	// on vérifie si la règle "cpt" est possible en x y avec l'entité id
	//console.log ("checking ",x,y,id);
	if (damier[x][y]!=id) {
		//console.log ("damier x y n'est pas ",id);
		return false;
	} 
	
	if (cpt.zone>=0) {
		if (cpt.zone!=damierZ[x][y]) {
			return false;
		}
	}
	
	if (checkEffCondCpt(cpt)===false) {
		return false;
	}

	var ent=entById(id);
	var ageMin=cpt.delai;

	
	if ((cpt.ctr===true)&&(cpt.tReac[0]!=id)) {return false;}  // si la case "le premier réactif au centre" est cochée
	
	var proba=cpt.proba;
		
	var reac=cpt.tReac.slice();
	var voisins=voisinsAutourDe(x,y);
	
	// y a-t-il de la place dans le voisinage
	if (voisins.filter(vo=>vo.id===0).length<cpt.bal) {return false;}
	
	// si des cases vides sont imposées dans les réactifs, y en a-t-il assez ?
	if (cpt.ncv>0) {
		if (voisins.filter(vo=>vo.id===0).length<cpt.ncv) {return false;}
	}
	
		
	// on simule la réaction
	var erreur=false;
	
	for (let r of reac) {
		if ((r[0]!="#")&&(r!="0")&&(r!="")) {
			// on retire un voisin de cet id
			let nv = voisins.findIndex(vo => vo.id === r*1);
			if (nv<0) {erreur=true;break;}
			if (indByXYandId(voisins[nv].x,voisins[nv].y,voisins[nv].id).age<ageMin) {erreur=true;break;}
			voisins[nv].id=0;
		}
	}
	
	if (erreur) {return false;}
	
	// reste-t-il assez de place pour les produits ?
	let casesVides=voisins.filter(vo=>vo.id===0);
	if (casesVides.length<cpt.nbProd) {
		// pas de place
		return false;
	}
	
	// tout semble OK
	return true;

}

//var tCt=[];
//tCt[0]=0;
//tCt[1]=0;
//tCt[2]=0;

function checkReactionsPossibles (i,j) {
	// i = numéro entité
	// j = numéro individu
	var ent=tEnt[i];
	var id=ent.id;
	var ind=ent.tInd[j];
	var x=ind.x;
	var y=ind.y;

	
	for (var k=0;k<tCpt.length;k++) {
		let cpt=tCpt[k];
		if (cpt.susp===false) {
			if (cpt.type=="reaction") {
				if (checkReacPossible (cpt,x,y,id)===true) {
					tReacPos.push({iCpt:k,x:x,y:y,id:id});
					//tCt[k]++;
					//console.log (tCt[0],tCt[1],tCt[2]);
				}	
			}
		}
	}
}

function testGenSpont () {
	function ajouteUneGenSpont(prod,zone,zone2) {
		let nProd=prod.length;
		
		if ((prod.length==0)&&(zone2>=0)) {
			// seulement changement de zone
			let c=findCaseVideZone(zone);
			if (c.x>=0) {
				damierZ[c.x][c.y]=zone2;
				zonesChanged=true;
			}
		} else {
			// génération spontanée d'agents
			for (var i=0;i<prod.length;i++) {
				let p=prod[i];
				if (p!="") {
					let c=findCaseVideZone(zone);
					if (c.x>=0) {
						rajouteEnt (p*1,c.x,c.y);
						if (zone2>=0) {
							damierZ[c.x][c.y]=zone2;
							zonesChanged=true;
						}
					}
				}
			}
		}		
	}
	
	
	for (var k=0;k<tCpt.length;k++) {
		let cpt=tCpt[k];
		if ((cpt.type=="spont")&&(cpt.susp===false)&&(checkEffCondCpt(cpt))) {
			if (cpt.probaSpont==100) {
				// plusieurs gen
				for (var j=0;j<cpt.nbSpont;j++) {
					 ajouteUneGenSpont(cpt.tProd,cpt.zone,cpt.zone2);
				}
			} else {
				// une seule gen mais improbable
				let probaSpont=cpt.probaSpont/100;
				if (Math.random()<probaSpont) {
					 ajouteUneGenSpont(cpt.tProd,cpt.zone,cpt.zone2);
				}
			}
		}
	}	
}


function testReactions () {
	// on vérifie les réactions possibles dans une première passe
	tReacPos=[];
	
	for (let i=0;i<tEnt.length;i++) {
		let ent=tEnt[i];
		for (let j=0;j<ent.tInd.length;j++) {
			checkReactionsPossibles(i,j);
		}
	}
}

function doReactions () {
	// 2ème passe
	//return false;
	
	// on mélange le tableau des comportements possibles
	shuffle(tReacPos);
	
	for (var cptPos of tReacPos) {
		let iCpt=cptPos.iCpt;
		let cpt=tCpt[iCpt];
		let id=cptPos.id;
		let x=cptPos.x;
		let y=cptPos.y;
		doReaction (cpt,x,y,id);
	}
}

function doReaction (cpt,x,y,id) {
	if ((Math.random()*100)>cpt.proba)  {return false;}
	// si il n'y a pas assez de place pour tout accueillir, on laisse tomber
	//console.log ("do reaction ",x,y,id);	
	if (nbMaxInd>0) {
		if ((nbTotalInd()+cpt.bal)>=nbMaxInd) {
			//console.log ("pas assez de place !");
			return false;
		}
	}
	
	if (checkReacPossible(cpt,x,y,id)===true) {
		var reac=cpt.tReac.slice();
		var prod=cpt.tProd.slice();
		var lk=cpt.tLink.slice();
		var keep=cpt.tKeep.slice();
		
		var tPosReac=[];
		var tAge=[];
		
		// on mémorise les positions 
		for (let i=0;i<5;i++) {
			tPosReac[i]={x:0,y:0}
		}
		
		// on commence par les spécifiques
		for (let i=0;i<reac.length;i++) {
			let r=reac[i];
			if ((r[0]!="#")&&(r!="0")&&(r!="")) {
				let voisins=voisinsAutourDe(x,y);
				shuffleSaufPremier(voisins); // la case centrale sera toujours prioritaire
				let ir=voisins.findIndex(vo => vo.id === r*1);
				let v=voisins[ir];
				tPosReac[i].x=v.x;
				tPosReac[i].y=v.y;
				let age=destroyEnt (v.x,v.y);
				//console.log ("destroy ",v.x,v.y);
				tAge[i]=age;
			}
		}
		
		
		if (prod.length>0) {
			// on rajoute les produits
			for (let i=0;i<prod.length;i++) {
				if (prod[i]!="") {
					if (lk[i]===true) {
						let age=0;
						if (keep[i]===true) {age=tAge[i];}
						rajouteEnt (prod[i]*1,tPosReac[i].x,tPosReac[i].y,age);
					} else {
						let cv=placesLibresAutourDe(x,y);
						shuffle(cv);
						rajouteEnt (prod[i]*1,cv[0].x,cv[0].y,0);
					}
				}
			}
		}
		// changement de zone ?
		if (cpt.zone2>=0) {
			damierZ[x][y]=cpt.zone2;
			zonesChanged=true;
		}
	} else {
		//console.log ("reaction pas possible !");
	}


}


function changeProbaSpont () {
	var v=byId("inputProbaSpont").value*1;
	if (v==100) {
		showId("divNombreProbaSpont");
	} else {
		hideId("divNombreProbaSpont");
	}
}

function checkCondEff (c) {
	if (c) {
		showId("divReglEff2");
	} else {
		hideId("divReglEff2");	
	}
}