var version="0.32";
var versionModeleCharge=version;
var lastModif="07/09/2019";
var modeExpert=true;
var lEcran,hEcran;
var menuVisible=false;
var menuAjoutVisible=false;
var originalAddMenu;
var nbCol=30;
var nbLig=30;
var lCanv,hCanv,lMain,hMain,fontSize,margeX,margeY;
var verbose=true;

var tScript=["FileSaver.min","fileOperations","gestComportements","gestEntites","gestPlacement","gestZones","gestGraph","gestTangente","gestImages","gestEnvironnement","jscolor.min","anim","controles"];
var nScript=0;

function start() {
	let urlParams = parseURLParams(window.location.href)||[]; 
	let verboseS=urlParams["verbose"]||"";
	verbose=(verboseS!="") ;
	chargeScripts();
}

function chargeScripts ()
{
	var nomf=tScript[nScript];
	nScript++;
	if (nScript<=tScript.length) {
		charge(nomf);	
	} else {
		go();
	}
}

function charge(nomf)
{
	var fileref=document.createElement('script');
	fileref.setAttribute("type","text/javascript");
	fileref.async = true;
	fileref.setAttribute("src", "js/"+nomf+".js");
	var js=document.getElementsByTagName("head")[0].appendChild(fileref);
    js.onload = function () {
		setTimeout(function() { 
			cons (nomf+" chargé.");
			chargeScripts();
		}, 5);      
	}
}


function cons(t) {
	if (verbose===true) {
		console.log (t);
	}
}

function cacheSplash() {
	if (byId("div_splash").style.display=="none") {return false;}
	if (swal.isVisible()) {return false;}
	redim();
	hideId("div_splash");
	showId("panneauCentre");
	redimGrille();
	resizeCanvGraph();
	traceGrille();
	redim();
	redimGrille();
	positionneEnvt();
}

function affModale (nom) {
	showId("masqueModal");
	showId(nom);	
}

function cacheModale () {
	hideId("masqueModal");	
}

function redim () {
	if (swal.isVisible()) {return false;} // évite un bug
	var dg=byId ("panneauGauche");
	var dl=byId ("panneauLegende");
	var ldg=dg.getBoundingClientRect().width;
	var hdl=dl.getBoundingClientRect().height;
	if (dl.style.display=="none") {hdl=0;}
	lEcran=document.body.clientWidth;
	hEcran=document.body.clientHeight;
	fontSize=Math.round(ldg*63)/1000;
	document.body.style.fontSize=fontSize+"px";
	
	lMain=lEcran-ldg*2;
	hMain=hEcran-hdl;
	
	byId("panneauCentre").style.width=lMain+"px";
	byId("panneauCentre").style.left=ldg+"px";
	
	redimGrille();
	resizeCanvGraph();	
	checkPosition (byId("divGraphique"));		
	checkPosition (byId("divDamier"));
	
	margeX=hEcran*0.04;
	margeY=hEcran*0.04;
}




function confirmExit() {
    return "You have attempted to leave this page. Are you sure?";
}
	

function go() {
	cons ("go");
	show(document.body);
	
	//window.onbeforeunload = confirmExit;
   
	updateVersion();
	
	let urlParams = parseURLParams(window.location.href)||[]; 
	let urlModeExpert = urlParams["expert"];
	if (typeof urlModeExpert!="undefined") {
		if (urlModeExpert=="1") {modeExpert=true}
		if (urlModeExpert=="0") {modeExpert=false}
	}
	let demoFilename=urlParams["demo"]||false;
	if (demoFilename!="") {
		loadDemo (demoFilename);
	} else {
		urlParamDemo=urlParams["modele"]||false;
		demoFilename=(urlParamDemo);
		if (demoFilename!="") {
			loadDemo (demoFilename);
		}
	}
	
	updateLigCol ();
	redim();
	dragElement(byId("divGraphique"));
	dragElement(byId("divDamier"));
	initResizeGraph();
	afficheGraphique(true);	
	byId("checkGraphique").checked=graphiqueVisible;
	byId("checkLegendeEnt").checked=legendeEntVisible;
	byId("checkGrilleVisible").checked=grilleVisible;
	initDamier();
	initDamierZone();
	
	byId('fileinput').addEventListener('change', readSingleFile, false);
	byId("checkLisseGraphique").checked=lissage;
	byId("inputRangLisse").value=rangLisse;
	animate();
	cons("animate");
	setTimeout (cacheSplash,1000);
	//setTimeout (clickDefinirZones,100);
	window.addEventListener("resize",redim);
	window.addEventListener('keydown',keyPressDamier);
	montreExpert (modeExpert);
}



function updateVersion () {
	byId("label_version").innerHTML=version+" ("+lastModif+")";
}

function eraseAll() {
	tan.pente="";
	clearTangente();
	deleteBG();
	tEnt=[];
	tZon=[];
	tImageEnt=[];
	tReacPos=[];
	tCpt=[];
	tGraph=[];
	selectedAgent=-1;
	iTemps=0;
	nbMaxInd=0;
	borderless=false;
	nbLig=30;
	nbCol=30;
	playing=false;
	traceEntites();
	traceGraph(true);
	updateLegende();
	refreshListeEnt();
	updateTableauxReacProd();
	updateLigCol();
	redimGrille();
	traceGrille();
	initDamierZone();
	traceZones();
	refreshListeCpt();
	refreshListeEnt();
	updateTours();
}

function nouveauModele () {
	if ((tEnt.length==0)&&(tCpt.length==0)&&(tZon.length==0)) {
		eraseAll ();
		return false;
	}

	
	swal({
		  title: 'Le modèle actuel va être fermé',
		  text: "Créer un autre modèle va fermer celui-ci. Etes vous sûr de vouloir poursuivre ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			eraseAll ();
			return false;
		  } else {
			return false;
		  }
		})
}

function goToMainScreen () {
	if ((tEnt.length==0)&&(tCpt.length==0)&&(tZon.length==0)) {
		window.location.href = '../index.htm';	
		return false;
	}	
	
	swal({
		  title: 'Le modèle actuel va être fermé',
		  text: "Retourner à l'écran d'accueil va entraîner la fermeture de ce modèle. Etes vous sûr de vouloir poursuivre ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			window.location.href = '../index.htm';	
			return false;
		  } else {
			return false;
		  }
		})
}

function checkExpert (c) {	
	modeExpert=c;
	montreExpert ();
}

function montreExpert () {
	var td=document.getElementsByClassName("expert");
	if (modeExpert) {s="block"} else {s="none"}
	for (let d of td) {
		d.style.display=s;
	}
	byId("checkExpert").checked=modeExpert;
}