var playing=false;
var deltaT=50; // en millièmes de seconde
var iTemps=0;
var mainZoom=100;

function checkZoom() {
	mainZoom=100;
	updateZoom();
	var maxX=0;
	var maxY=0;
	for (var i=1;i<tVar.length;i++) {
		var v=tVar[i];
		var divVar=byId('var'+to2digits(i));
		var r=divVar.getBoundingClientRect().right;
		var b=divVar.getBoundingClientRect().bottom;
		if ((!v.suppr)&&(r>maxX)) {
			maxX=r;
		}	
		if ((!v.suppr)&&(b>maxY)) {
			maxY=b;
		}				
	}
	for (var i=1;i<tTxt.length;i++) {
		var v=tTxt[i];
		var divVar=byId('txt'+to2digits(i));
		var r=divVar.getBoundingClientRect().right;
		var b=divVar.getBoundingClientRect().bottom;
		if ((!v.suppr)&&(r>maxX)) {
			maxX=r;
		}	
		if ((!v.suppr)&&(b>maxY)) {
			maxY=b;
		}				
	}
	for (var i=1;i<tLien.length;i++) {
		var v=tLien[i];
		var divVar=byId('ctr'+to2digits(i));
		var r=divVar.getBoundingClientRect().right;
		var b=divVar.getBoundingClientRect().bottom;
		if ((!v.suppr)&&(r>maxX)) {
			maxX=r;
		}	
		if ((!v.suppr)&&(b>maxY)) {
			maxY=b;
		}				
	}
	
	if ((maxX>lEcran)||(maxY>hEcran)) {
		var r1=lEcran/maxX;
		var r2=hEcran/maxY;
		var r=Math.min(r1,r2)*0.999;
	
		mainZoom=mainZoom*r;
		updateZoom();
	}
}

function updateZoom () {
	byId("div_conteneur_modele").style.fontSize=Math.round(mainZoom*10)/1000+"em";
	updateAllVar();
	updateAllSVG();
}

function animate () {
	if (playing) {
		recalcAllVars ();
		traceGraph();
		
		iTemps++;
	}
	setTimeout (animate,deltaT);
}

function playPause () {
	playing=!playing;
	var divPlay=byId ("bouton_play");
	if (!playing) {
		divPlay.style.backgroundImage = "url('../common/images/sqplay.png')";
	} else {
		divPlay.style.backgroundImage = "url('../common/images/sqpause.png')";	
	}
}

function evolSpont (nId) {
	// évolution spontanée de la variable n°nId
	var v=tVar[nId];
	if (v.suppr) {return false;}
	if (!v.actif) {return false;}
	if ((v.typeVar!="d")&&(v.typeVar!="n")) {return false;}
	if (v.nullVal) {return false;}
	if (modifyingVar==nId) {return false;}
	if (v.typeSpont=="0") {return false;}
	
	v.val=v.val*1;

	if (v.typeSpont=="d") {
		// disparitions spontanées
		if (v.dispaType=="p") {
			v.val=v.val-v.val*v.dispaVal/100*deltaT/1000;
		} else {
			v.val=v.val-v.dispaVal*deltaT/1000;
		}
		// créations spontanées
		if (v.creaType=="p") {
			v.val=v.val+v.val*v.creaVal/100*deltaT/1000;
		} else {
			v.val=v.val+v.creaVal*deltaT/1000;
		}		
		
	}
	
	if (v.typeSpont=="t") {
		// on recentre vers la valeur cible
		var c=v.forceSpont*deltaT/1000;
		v.val=(v.val+v.cibleSpont*c)/(1+c);
	}

	checkRange(nId);
}

function recalcAllVars () {
	// évolution spontanée
	for (var i=1;i<tVar.length;i++) {
		evolSpont (i);
	}

	
	// prise en compte des liens agissant sur la variation des substances et grandeurs
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		if (lien.typeRel=="taux") {
			var idV2=lien.idV2;
			var v2=tVar[idV2*1];
			
			var taux=calcEffet (i);
			if (taux!=false) {
				v2.val=v2.val*1+taux*1;
				checkRange(idV2*1);
			}
		}
	}
	
	// calcul des dy/dt
	calcdydt();
	
	updateAllPheno ();
	
	updateAllVarCalc ();
	
	updateAllVarDeri ();
		
	updateAllVar();

	// mise à jour du graph
	var v;
	for (var i=1;i<tVar.length;i++) {
		
		if (tVar[i].nullVal) {v=0;} else 
		{v=tVar[i].val*1;}
		
		tg[i].graph[iTemps%nbMaxVal]=v;
	}
}

function calcEffet (id) {
	// calcul l'effet du lien id
	var nId=id*1;
	id=to2digits(nId);
	var lien=tLien[nId];
	var idV1=lien.idV1;
	var idV2=lien.idV2;
	var delai=lien.delai;
	var v1=tVar[idV1*1];
	var v2=tVar[idV2*1];

	var vActif=v1.actif&&v2.actif&&lien.actif; // on vérifie que les 2 var sont actives, ainsi que le lien
	
	if ( ((idV2*1)!=modifyingVar )&&(!v2.nullVal)&&(vActif===true) ) { // on n'a pas touché à la valeur avec le range, les variables sont actives et le lien est actif
		if (v2.typeVar=="d") { // ce genre de lien n'agit que sur une variable dynamique
			var x=valDecal(idV1*1,delai);
			var taux=calcValEffet (lien,x);
			return taux*1;
		}
	} else {
		return false;
	}
	
}

function calcValEffet (lien,x) {
	var seuil=lien.seuil;
	var idV1=lien.idV1;
	var v1=tVar[idV1*1];
	try {
		var taux=math.eval (lien.formule,{x:x})*1;
	}
	catch (error) {
		return false;
	}
	
	if (lien.seuilneg==false) { // si en dessous du seuil => pas d'effet
		if ( x<seuil) {taux=0;} // si x<0 pas d'effet
	}
	return taux*1;
}

function updateAllPheno () {
	// vérification des phénomènes 
	for (var j=1;j<tVar.length;j++) {
		checkActifPheno (j);
	}
}


function updateAllVar () {
	for (var i=1;i<tVar.length;i++) {
		updateVar (i);
	}
}
