function saveJson () {
	closeMenu();
	storeCoords();
	var tAll=new Object ();
	tAll.typeMod="ana";
	tAll.tVar=tVar;
	tAll.tLien=tLien;
	tAll.tTxt=tTxt;
	tAll.nomModele=nomModele;
	tAll.auteurs=auteurs;
	tAll.nbSig=nbSig;
	var allJson=JSON.stringify(tAll); 
	
	swal({   
		title: "Nom du fichier (sans extension)",   
		text: "Saisir le nom du fichier qui contiendra le modèle",   
		input: "text",
		showCancelButton: true,   
		allowEscapeKey:true,
		animation: "slide-from-top",   
		inputPlaceholder: "monModele" })
		.then(function(result) {
			if (result.value) {
				var fileNameToSaveAs=result.value;
				if (fileNameToSaveAs===null) {return false;}
				saveToText (fileNameToSaveAs+".modele",allJson);			
			}
        });
	
}

function saveJsonTemplate () {
	closeMenu();
	storeCoords();
	var tAll=new Object ();
	tAll.typeMod="template";
	tAll.tVar=convertTVarToTemplate();
	var allJson=JSON.stringify(tAll); 
	
	swal({   
		title: "Nom du fichier (sans extension)",   
		text: "Saisir le nom du fichier qui contiendra le template",   
		input: "text",
		showCancelButton: true,   
		allowEscapeKey:true,
		animation: "slide-from-top",   
		inputPlaceholder: "monModele" })
		.then(function(result) {
			if (result.value) {
				var fileNameToSaveAs=result.value;
				if (fileNameToSaveAs===null) {return false;}
				saveToText (fileNameToSaveAs+".tmp",allJson);			
			}
        });
	
}

function saveCSVGraph () {
	closeMenu();
	var txt="\ufeff";
	txt+="Temps;";
	for (var j=1;j<tVar.length;j++) {
		va=tVar[j];
		if ((va.actif)&&(va.affGraph)) {
			txt+=va.nom+";";
		}
	}
	txt+="\r\n";
	
	var iDebut=iTemps-ltGraph;
	if (iDebut<0) {iDebut=0;}
	for (var i=iDebut;i<iTemps;i++) {
		var ligne="";
		ligne+=i*deltaT/1000+";";
		ii=i%nbMaxVal;
		for (var j=1;j<tVar.length;j++) {
			va=tVar[j];
			if ((va.actif)&&(va.affGraph)) {
				ligne+=v=tg[j].graph[ii]+";";
			}
		}
		ligne+="\r\n";
		ligne=ligne.replace (/\./g,",");
		txt+=ligne;
	}
	
	swal({   
		title: "Nom du fichier (sans extension)",   
		text: "Saisir le nom du fichier qui contiendra les données du graphique",   
		input: "text",
		showCancelButton: true,   
		allowEscapeKey:true,
		animation: "slide-from-top",   
		inputValue: "monGraphique",
		inputPlaceholder: "monGraphique" })
		.then(function(result) {
			if (result.value) {
				var fileNameToSaveAs=result.value;
				if (fileNameToSaveAs===null) {return false;}
				saveToText (fileNameToSaveAs+".csv",txt);
			}
        });
}

function storeCoords () {
	var fss=window.getComputedStyle(document.getElementById("div_conteneur_modele"), null).getPropertyValue('font-size');
	var fs=parseFloat(fss, 10)*1;
	//var fs=mainZoom/100;
	for (var i=1;i<tVar.length;i++) {
		var v=tVar[i];
		var divVar=document.getElementById("var"+to2digits(i));
		var rect=divVar.getBoundingClientRect();
		v.left=sigFigs(rect.left/fs,5);
		v.top=sigFigs(rect.top/fs,5);
	}
	
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		var ctrc=document.getElementById("ctr"+to2digits(i));
		var rect=ctrc.getBoundingClientRect();
		lien.left=sigFigs(rect.left/fs,5);
		lien.top=sigFigs(rect.top/fs,5);
	}
	
	for (var i=1;i<tTxt.length;i++) {
		var txt=tTxt[i];
		var divTxt=document.getElementById("txt"+to2digits(i));
		var rect=divTxt.getBoundingClientRect();
		txt.left=sigFigs(rect.left/fs,5);
		txt.top=sigFigs(rect.top/fs,5);
	}
}


function saveToText(fileNameToSaveAs,textToWrite)
{
	var blob = new Blob([textToWrite], {
		type: "text/plain;charset=utf-8"
	});
	saveAs(blob, fileNameToSaveAs);
}


function destroyClickedElement(event)
{
    document.body.removeChild(event.target);
}

function loadJson (textLoaded) {
	var tAll=JSON.parse(textLoaded);	
	
	let typeMod=tAll.typeMod;
	
	if (typeof typeMod!="undefined") {
		if (typeMod!="ana") {
			if (typeMod=="algo") {
				// ce fichier doit s'ouvrir avec algo
				swal({
				  title: 'Modèle algorithmique',
				  text: "Ce modèle a été créé avec le module algorithmique. Voulez-vous basculer vers ce module ?",
				  type: 'warning',
				  showCancelButton: true,
				  confirmButtonColor: '#3085d6',
				  cancelButtonColor: '#d33',
				  confirmButtonText: 'Oui',
				  cancelButtonText: 'Non',
				  confirmButtonClass: 'btn btn-success',
				  cancelButtonClass: 'btn btn-danger',
				  buttonsStyling: true,
				  reverseButtons: false
				}).then((result) => {
				  if (result.value) {
					window.location.replace('../algo/index.htm');
					return false;
				  } else {
					return false;
				  }
				})
			}
			
			else {
				
				// mode inconnu
				swal({
				  type: 'error',
				  title: 'Erreur',
				  text: 'Ce fichier n\'a pas été prévu pour ce module d\'Edumodèle !'
				})
				return false;
			
			}
			return false;
		}
		
	}
	

	var ech=1;
	
	for (var i=1;i<tAll.tVar.length;i++) {creeDivVar ();}
	for (var i=1;i<tAll.tVar.length;i++) {
		var v=tAll.tVar[i];
		v.left=v.left*ech;
		v.top=v.top*ech;
		tVar[i]=v;
		adapteTypeVar(to2digits(i));
		repositionneVar(i);
	}
	
	for (var i=1;i<tAll.tTxt.length;i++) {creeDivTxt ();}
	for (var i=1;i<tAll.tTxt.length;i++) {
		var v=tAll.tTxt[i];
		v.left=v.left*ech;
		v.top=v.top*ech;
		tTxt[i]=v;
		updateTxt(to2digits(i));
	}
	
	for (var i=1;i<tAll.tLien.length;i++) {
		creeCourbe (i)
		creeCtr (i);
	}
	for (var i=1;i<tAll.tLien.length;i++) {
		var id=to2digits(i);
		var lien=tAll.tLien[i];
		lien.left=lien.left*ech;
		lien.top=lien.top*ech;
		tLien[i]=lien;
		deplacePoignee(id,lien.left+"em",lien.top+"em");
		updateSVG(id);
		updateLien(id);
	}
	
	if (typeof(tAll.auteurs)!="undefined") {auteurs=tAll.auteurs} else {auteurs=""}
	if (typeof(tAll.nbSig)!="undefined") {nbSig=tAll.nbSig} else {nbSig=5}
	if (typeof(tAll.nomModele)!="undefined") {nomModele=tAll.nomModele} else {nomModele=""}

	updateTitre();
	
	recalcAllOpaLien();
	
	restart();
	updateZoom();
	checkZoom();
}


function loadJsonTemplate (textLoaded) {
	var tAll=JSON.parse(textLoaded);	
	tVarTempl=tAll.tVar;
	changeMenuTemplate(tAll);
}

function readSingleFile(evt) {
	closeMenu();
	if ((tVar.length>1)||(tTxt.length>1)) {
		swal({
		  title: 'Le modèle actuel va être fermé',
		  text: "Charger un autre modèle va fermer celui-ci. Etes vous sûr de vouloir poursuivre ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			eraseAllStep2 ();
			readSingleFilePart2 (evt);
		  } else {
			return false;
		  }
		})
	} else {
		// modèle vide, on peut y aller direct
		eraseAllStep2 ();
		readSingleFilePart2(evt);
	}
}


	
function readSingleFilePart2(evt) {	
	//Retrieve the first (and only!) File from the FileList object
	var f = evt.target.files[0]; 

	if (f) {
	  var r = new FileReader();
	  r.onload = function(e) { 
		var contents = e.target.result;
		loadJson(contents);
	  }
	  r.readAsText(f);
	} else { 
	  	swal({
		  type: 'error',
		  title: 'Erreur',
		  text: 'Impossible de lire le fichier !'
		})
	}
	byId('fileinput').value = null;
 }
 
 function readSingleFileTemplate(evt) {
	closeMenu();
	readSingleFileTemplatePart2(evt);
}


	
function readSingleFileTemplatePart2(evt) {	
	//Retrieve the first (and only!) File from the FileList object
	var f = evt.target.files[0]; 

	if (f) {
	  var r = new FileReader();
	  r.onload = function(e) { 
		var contents = e.target.result;
		loadJsonTemplate(contents);
	  }
	  r.readAsText(f);
	} else { 
	  	swal({
		  type: 'error',
		  title: 'Erreur',
		  text: 'Impossible de lire le fichier !'
		})
	}
	byId('fileinput').value = null;
 }
 

function moveAllXY (x,y) {
	storeCoords();
	for (var i=1;i<tLien.length;i++) {
		var lien=tLien[i];
		var id=to2digits(i);
		lien.left=lien.left*1+x;
		lien.top=lien.top*1+y;
		deplacePoignee(to2digits(i),lien.left+"em",lien.top+"em");
	}
	
	for (var i=1;i<tVar.length;i++) {
		var v=tVar[i];
		v.left=v.left*1+x;
		v.top=v.top*1+y;
		repositionneVar(i);
	}	
	
	for (var i=1;i<tTxt.length;i++) {
		var v=tTxt[i];
		v.left=v.left*1+x;
		v.top=v.top*1+y;
		updateTxt(to2digits(i));
	}	
	updateAllSVG();
}

function allegeTxt (v) {
	if (v.suppr!=true) {delete v.suppr;}
}

function allegeVar(v) {
	// supprime les champs inutiles
	if (v.suppr!=true) {delete v.suppr;}
	if (v.typeVar!="p") {
		delete v.nomActif;
		delete v.nomInactif;
		delete v.pCondition;
		delete v.pActif;
	}
	if ((v.typeVar=="d")||(v.typeVar=="n")) {
		delete v.typeCalc;
		delete v.formCalc;
	}
	if ((v.typeVar=="v")||(v.typeVar=="c")) {
		delete v.typeSpont;
		delete v.creaType;
		delete v.creaVal;
		delete v.dispaType;
		delete v.dispaVal;
	}
}